var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.default=exports._taskLog=exports._taskStart=exports._taskConfigure=void 0;var _regenerator=_interopRequireDefault(require("@babel/runtime/regenerator"));
var _betterOpn=_interopRequireDefault(require("better-opn"));
var _common=require("../../common");




var _platformTools=require("../../platformTools");
var _projectTools=require("../../projectTools");
var _logger=require("../../systemTools/logger");
var _constants=require("../../constants");





var _electron=require("../../platformTools/electron");






var _config=_interopRequireDefault(require("../../config"));
var _analytics=_interopRequireDefault(require("../../systemTools/analytics"));
var _sdkManager=require("../../platformTools/sdkManager");
var _pluginTools=require("../../pluginTools");

var TASKS={};

var _taskConfigure=function _taskConfigure(c,parentTask){return _regenerator.default.async(function _taskConfigure$(_context){while(1){switch(_context.prev=_context.next){case 0:
(0,_logger.logTask)('_taskConfigure',"parent:"+parentTask);_context.next=3;return _regenerator.default.awrap(

(0,_platformTools.configureGenericPlatform)(c));case 3:_context.next=5;return _regenerator.default.awrap(
(0,_projectTools.configureGenericProject)(c));case 5:_context.t0=

c.platform;_context.next=_context.t0===
_constants.MACOS?8:_context.t0===
_constants.WINDOWS?8:9;break;case 8:return _context.abrupt("return",
(0,_electron.configureElectronProject)(c));case 9:return _context.abrupt("return",

(0,_common.logErrorPlatform)(c));case 10:case"end":return _context.stop();}}},null,null,null,Promise);};exports._taskConfigure=_taskConfigure;


TASKS[_constants.TASK_CONFIGURE]=_taskConfigure;

var _taskStart=function _taskStart(c,parentTask){var platform,port,hosted;return _regenerator.default.async(function _taskStart$(_context2){while(1){switch(_context2.prev=_context2.next){case 0:
platform=c.platform;
port=c.runtime.port;
hosted=c.program.hosted;

(0,_logger.logTask)('_taskStart',"parent:"+parentTask+" port:"+c.runtime.port+" hosted:"+!!hosted);

if(_config.default.isWebHostEnabled&&hosted){
(0,_common.waitForWebpack)(c).
then(function(){return(0,_betterOpn.default)("http://"+c.runtime.localhost+":"+port+"/");}).
catch(_logger.logError);
}if(

c.program.only){_context2.next=8;break;}_context2.next=8;return _regenerator.default.awrap(
_taskConfigure(c));case 8:_context2.t0=


platform;_context2.next=_context2.t0===
_constants.MACOS?11:_context2.t0===
_constants.WINDOWS?11:12;break;case 11:return _context2.abrupt("return",
(0,_electron.runElectronDevServer)(c,platform,port));case 12:return _context2.abrupt("return",

(0,_common.logErrorPlatform)(c,platform));case 13:case"end":return _context2.stop();}}},null,null,null,Promise);};exports._taskStart=_taskStart;


TASKS[_constants.TASK_START]=_taskStart;

var _taskRun=function _taskRun(c,parentTask){var platform,port,target,hosted;return _regenerator.default.async(function _taskRun$(_context3){while(1){switch(_context3.prev=_context3.next){case 0:
platform=c.platform;
port=c.runtime.port;
target=c.runtime.target;
hosted=c.program.hosted;
(0,_logger.logTask)('_taskRun',"parent:"+parentTask+" port:"+port+" target:"+target+" hosted:"+hosted);if(

c.program.only){_context3.next=8;break;}_context3.next=8;return _regenerator.default.awrap(
_taskConfigure(c));case 8:_context3.t0=


platform;_context3.next=_context3.t0===
_constants.MACOS?11:_context3.t0===
_constants.WINDOWS?11:12;break;case 11:return _context3.abrupt("return",
(0,_electron.runElectron)(c,platform,port));case 12:return _context3.abrupt("return",

(0,_common.logErrorPlatform)(c,platform));case 13:case"end":return _context3.stop();}}},null,null,null,Promise);};


TASKS[_constants.TASK_RUN]=_taskRun;

var _taskPackage=function _taskPackage(c,parentTask){var platform;return _regenerator.default.async(function _taskPackage$(_context4){while(1){switch(_context4.prev=_context4.next){case 0:
(0,_logger.logTask)('_taskPackage',"parent:"+parentTask);
platform=c.platform;_context4.t0=


platform;_context4.next=5;break;case 5:

(0,_common.logErrorPlatform)(c,platform);return _context4.abrupt("return",
false);case 7:case"end":return _context4.stop();}}},null,null,null,Promise);};


TASKS[_constants.TASK_PACKAGE]=_taskPackage;

var _taskExport=function _taskExport(c,parentTask){var platform;return _regenerator.default.async(function _taskExport$(_context5){while(1){switch(_context5.prev=_context5.next){case 0:
(0,_logger.logTask)('_taskExport',"parent:"+parentTask);
platform=c.platform;if(

c.program.only){_context5.next=5;break;}_context5.next=5;return _regenerator.default.awrap(
_taskBuild(c));case 5:_context5.t0=


platform;_context5.next=_context5.t0===
_constants.MACOS?8:_context5.t0===
_constants.WINDOWS?8:9;break;case 8:return _context5.abrupt("return",
(0,_electron.exportElectron)(c,platform));case 9:

(0,_common.logErrorPlatform)(c,platform);case 10:case"end":return _context5.stop();}}},null,null,null,Promise);};


TASKS[_constants.TASK_EXPORT]=_taskExport;

var _taskBuild=function _taskBuild(c,parentTask){var platform;return _regenerator.default.async(function _taskBuild$(_context6){while(1){switch(_context6.prev=_context6.next){case 0:
(0,_logger.logTask)('_taskBuild',"parent:"+parentTask);
platform=c.platform;if(



c.program.only){_context6.next=5;break;}_context6.next=5;return _regenerator.default.awrap(
_taskConfigure(c));case 5:_context6.t0=


platform;_context6.next=_context6.t0===
_constants.MACOS?8:_context6.t0===
_constants.WINDOWS?8:11;break;case 8:_context6.next=10;return _regenerator.default.awrap(
(0,_electron.buildElectron)(c,platform));case 10:return _context6.abrupt("return");case 11:


(0,_common.logErrorPlatform)(c,platform);case 12:case"end":return _context6.stop();}}},null,null,null,Promise);};


TASKS[_constants.TASK_BUILD]=_taskBuild;

var _taskDeploy=function _taskDeploy(c,parentTask){var platform;return _regenerator.default.async(function _taskDeploy$(_context7){while(1){switch(_context7.prev=_context7.next){case 0:
(0,_logger.logTask)('_taskDeploy',"parent:"+parentTask);
platform=c.platform;_context7.t0=

platform;_context7.next=5;break;case 5:if(

c.program.only){_context7.next=8;break;}_context7.next=8;return _regenerator.default.awrap(
_taskExport(c));case 8:case"end":return _context7.stop();}}},null,null,null,Promise);};



TASKS[_constants.TASK_DEPLOY]=_taskDeploy;

var _taskDebug=function _taskDebug(c){var platform;return _regenerator.default.async(function _taskDebug$(_context8){while(1){switch(_context8.prev=_context8.next){case 0:
(0,_logger.logTask)("_taskDebug:"+c.platform);
platform=c.platform;

switch(platform){
default:
(0,_common.logErrorPlatform)(c,platform);}case 3:case"end":return _context8.stop();}}},null,null,null,Promise);};


TASKS[_constants.TASK_DEBUG]=_taskDebug;

var runTask=function runTask(c,task){return _regenerator.default.async(function runTask$(_context9){while(1){switch(_context9.prev=_context9.next){case 0:
(0,_logger.logTask)('runTask','(engine-rn-electron)');_context9.next=3;return _regenerator.default.awrap(

(0,_platformTools.isPlatformSupported)(c));case 3:_context9.next=5;return _regenerator.default.awrap(
(0,_common.isBuildSchemeSupported)(c));case 5:_context9.next=7;return _regenerator.default.awrap(
(0,_sdkManager.checkSdk)(c));case 7:_context9.next=9;return _regenerator.default.awrap(
applyTemplate(c));case 9:_context9.next=11;return _regenerator.default.awrap(
(0,_pluginTools.resolvePluginDependants)(c));case 11:

_analytics.default.captureEvent({
type:task+"Project",
platform:c.platform});return _context9.abrupt("return",

TASKS[task](c));case 13:case"end":return _context9.stop();}}},null,null,null,Promise);};


var _taskLog=function _taskLog(c){return _regenerator.default.async(function _taskLog$(_context10){while(1){switch(_context10.prev=_context10.next){case 0:
(0,_logger.logTask)("_taskLog:"+c.platform);
switch(c.platform){
default:
(0,_common.logErrorPlatform)(c,c.platform);}case 2:case"end":return _context10.stop();}}},null,null,null,Promise);};exports._taskLog=_taskLog;


TASKS[_constants.TASK_LOG]=_taskLog;

var applyTemplate=function applyTemplate(){return _regenerator.default.async(function applyTemplate$(_context11){while(1){switch(_context11.prev=_context11.next){case 0:return _context11.abrupt("return",true);case 1:case"end":return _context11.stop();}}},null,null,null,Promise);};var _default=

{
runTask:runTask,
applyTemplate:applyTemplate};exports.default=_default;
//# sourceMappingURL=index.js.map