var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.default=exports._taskLog=exports._taskStart=exports._taskConfigure=void 0;var _regenerator=_interopRequireDefault(require("@babel/runtime/regenerator"));
var _betterOpn=_interopRequireDefault(require("better-opn"));
var _ip=_interopRequireDefault(require("ip"));
var _path=_interopRequireDefault(require("path"));

var _common=require("../../common");




var _platformTools=require("../../platformTools");
var _projectTools=require("../../projectTools");
var _logger=require("../../systemTools/logger");
var _constants=require("../../constants");












var _web=require("../../platformTools/web");
var _tizen=require("../../platformTools/tizen");
var _webos=require("../../platformTools/webos");
var _firefox=require("../../platformTools/firefox");
var _chromecast=require("../../platformTools/chromecast");
var _fileutils=require("../../systemTools/fileutils");
var _exec=require("../../systemTools/exec");
var _config=_interopRequireDefault(require("../../config"));
var _analytics=_interopRequireDefault(require("../../systemTools/analytics"));
var _sdkManager=require("../../platformTools/sdkManager");
var _pluginTools=require("../../pluginTools");

var TASKS={};

var _taskConfigure=function _taskConfigure(c,parentTask){return _regenerator.default.async(function _taskConfigure$(_context){while(1){switch(_context.prev=_context.next){case 0:
(0,_logger.logTask)('_taskConfigure',"parent:"+parentTask);_context.next=3;return _regenerator.default.awrap(

(0,_platformTools.configureGenericPlatform)(c));case 3:_context.next=5;return _regenerator.default.awrap(
(0,_projectTools.configureGenericProject)(c));case 5:_context.t0=

c.platform;_context.next=_context.t0===
_constants.WEB?8:_context.t0===

_constants.TIZEN?9:_context.t0===
_constants.TIZEN_MOBILE?9:_context.t0===
_constants.TIZEN_WATCH?9:_context.t0===

_constants.WEBOS?10:_context.t0===

_constants.CHROMECAST?11:_context.t0===

_constants.FIREFOX_OS?12:_context.t0===
_constants.FIREFOX_TV?12:_context.t0===
_constants.KAIOS?12:13;break;case 8:return _context.abrupt("return",(0,_web.configureWebProject)(c));case 9:return _context.abrupt("return",(0,_tizen.configureTizenProject)(c));case 10:return _context.abrupt("return",(0,_webos.configureWebOSProject)(c));case 11:return _context.abrupt("return",(0,_chromecast.configureChromecastProject)(c));case 12:return _context.abrupt("return",
(0,_firefox.configureKaiOSProject)(c));case 13:return _context.abrupt("return",

(0,_common.logErrorPlatform)(c,c.platform));case 14:case"end":return _context.stop();}}},null,null,null,Promise);};exports._taskConfigure=_taskConfigure;


TASKS[_constants.TASK_CONFIGURE]=_taskConfigure;

var _configureHostedIfRequired=function _configureHostedIfRequired(c){var _c$paths,project,rnv;return _regenerator.default.async(function _configureHostedIfRequired$(_context2){while(1){switch(_context2.prev=_context2.next){case 0:
(0,_logger.logTask)("_configureHostedIfRequired:"+c.platform);
if(_config.default.isWebHostEnabled){
(0,_logger.logDebug)('Running hosted build');_c$paths=
c.paths,project=_c$paths.project,rnv=_c$paths.rnv;
(0,_fileutils.copyFolderContentsRecursiveSync)(
_path.default.join(rnv.dir,'supportFiles','appShell'),
_path.default.join(
project.dir,
'platformBuilds',
c.runtime.appId+"_"+c.platform,
'public'));


(0,_fileutils.writeCleanFile)(
_path.default.join(rnv.dir,'supportFiles','appShell','index.html'),
_path.default.join(
project.dir,
'platformBuilds',
c.runtime.appId+"_"+c.platform,
'public',
'index.html'),

[
{
pattern:'{{DEV_SERVER}}',
override:"http://"+_ip.default.address()+":"+c.runtime.port}],

null,c);

}case 2:case"end":return _context2.stop();}}},null,null,null,Promise);};


var _taskStart=function _taskStart(c,parentTask){var platform,port,hosted;return _regenerator.default.async(function _taskStart$(_context3){while(1){switch(_context3.prev=_context3.next){case 0:
platform=c.platform;
port=c.runtime.port;
hosted=c.program.hosted;

(0,_logger.logTask)('_taskStart',"parent:"+parentTask+" port:"+c.runtime.port+" hosted:"+!!hosted);if(

c.program.only){_context3.next=7;break;}_context3.next=7;return _regenerator.default.awrap(
_taskConfigure(c));case 7:


if(_config.default.isWebHostEnabled&&hosted){
(0,_common.waitForWebpack)(c).
then(function(){return(0,_betterOpn.default)("http://"+c.runtime.localhost+":"+port+"/");}).
catch(_logger.logError);
}_context3.t0=

platform;_context3.next=_context3.t0===
_constants.WEB?11:_context3.t0===
_constants.TIZEN?11:_context3.t0===
_constants.WEBOS?11:_context3.t0===
_constants.TIZEN_MOBILE?11:_context3.t0===
_constants.TIZEN_WATCH?11:12;break;case 11:return _context3.abrupt("return",
(0,_web.runWeb)(c,platform,port));case 12:if(!

hosted){_context3.next=14;break;}return _context3.abrupt("return",
(0,_logger.logError)(
'This platform does not support hosted mode',
true));case 14:return _context3.abrupt("return",


(0,_common.logErrorPlatform)(c,platform));case 15:case"end":return _context3.stop();}}},null,null,null,Promise);};exports._taskStart=_taskStart;


TASKS[_constants.TASK_START]=_taskStart;

var _taskRun=function _taskRun(c,parentTask){var platform,port,target,hosted;return _regenerator.default.async(function _taskRun$(_context4){while(1){switch(_context4.prev=_context4.next){case 0:
platform=c.platform;
port=c.runtime.port;
target=c.runtime.target;
hosted=c.program.hosted;
(0,_logger.logTask)('_taskRun',"parent:"+parentTask+" port:"+port+" target:"+target+" hosted:"+hosted);if(!(

_config.default.isWebHostEnabled&&hosted)){_context4.next=8;break;}
c.runtime.shouldOpenBrowser=true;return _context4.abrupt("return",
_taskStart(c));case 8:if(


c.program.only){_context4.next=11;break;}_context4.next=11;return _regenerator.default.awrap(
_taskConfigure(c));case 11:_context4.t0=


platform;_context4.next=_context4.t0===
_constants.WEB?14:_context4.t0===


_constants.TIZEN?16:_context4.t0===
_constants.TIZEN_MOBILE?16:_context4.t0===
_constants.TIZEN_WATCH?16:_context4.t0===




_constants.WEBOS?20:_context4.t0===




_constants.KAIOS?24:_context4.t0===
_constants.FIREFOX_OS?24:_context4.t0===
_constants.FIREFOX_TV?24:_context4.t0===

_constants.CHROMECAST?25:29;break;case 14:c.runtime.shouldOpenBrowser=true;return _context4.abrupt("return",(0,_web.runWeb)(c,platform,port,true));case 16:if(c.program.only){_context4.next=19;break;}_context4.next=19;return _regenerator.default.awrap(_configureHostedIfRequired(c));case 19:return _context4.abrupt("return",(0,_tizen.runTizen)(c,platform,target));case 20:if(c.program.only){_context4.next=23;break;}_context4.next=23;return _regenerator.default.awrap(_configureHostedIfRequired(c));case 23:return _context4.abrupt("return",(0,_webos.runWebOS)(c));case 24:return _context4.abrupt("return",(0,_firefox.runFirefoxProject)(c,platform));case 25:if(
c.program.only){_context4.next=28;break;}_context4.next=28;return _regenerator.default.awrap(
_configureHostedIfRequired(c));case 28:return _context4.abrupt("return",

(0,_chromecast.runChromecast)(c,platform,target));case 29:return _context4.abrupt("return",

(0,_common.logErrorPlatform)(c,platform));case 30:case"end":return _context4.stop();}}},null,null,null,Promise);};


TASKS[_constants.TASK_RUN]=_taskRun;

var _taskPackage=function _taskPackage(c,parentTask){var platform;return _regenerator.default.async(function _taskPackage$(_context5){while(1){switch(_context5.prev=_context5.next){case 0:
(0,_logger.logTask)('_taskPackage',"parent:"+parentTask);
platform=c.platform;if(

c.program.only){_context5.next=5;break;}_context5.next=5;return _regenerator.default.awrap(
_taskConfigure(c));case 5:_context5.t0=


platform;_context5.next=8;break;case 8:

(0,_common.logErrorPlatform)(c,platform);return _context5.abrupt("return",
false);case 10:case"end":return _context5.stop();}}},null,null,null,Promise);};


TASKS[_constants.TASK_PACKAGE]=_taskPackage;

var _taskExport=function _taskExport(c,parentTask){var platform;return _regenerator.default.async(function _taskExport$(_context6){while(1){switch(_context6.prev=_context6.next){case 0:
(0,_logger.logTask)('_taskExport',"parent:"+parentTask);

platform=c.platform;if(

c.program.only){_context6.next=5;break;}_context6.next=5;return _regenerator.default.awrap(
_taskBuild(c));case 5:_context6.t0=


platform;_context6.next=_context6.t0===
_constants.WEB?8:9;break;case 8:return _context6.abrupt("return",
(0,_web.exportWeb)(c,platform));case 9:

(0,_common.logErrorPlatform)(c,platform);case 10:case"end":return _context6.stop();}}},null,null,null,Promise);};


TASKS[_constants.TASK_EXPORT]=_taskExport;

var _taskBuild=function _taskBuild(c,parentTask){var platform;return _regenerator.default.async(function _taskBuild$(_context7){while(1){switch(_context7.prev=_context7.next){case 0:
(0,_logger.logTask)('_taskBuild',"parent:"+parentTask);

platform=c.platform;if(

c.program.only){_context7.next=5;break;}_context7.next=5;return _regenerator.default.awrap(
_taskConfigure(c));case 5:_context7.t0=


platform;_context7.next=_context7.t0===
_constants.WEB?8:_context7.t0===
_constants.CHROMECAST?8:_context7.t0===


_constants.KAIOS?11:_context7.t0===
_constants.FIREFOX_OS?11:_context7.t0===
_constants.FIREFOX_TV?11:_context7.t0===


_constants.TIZEN?14:_context7.t0===
_constants.TIZEN_MOBILE?14:_context7.t0===
_constants.TIZEN_WATCH?14:_context7.t0===


_constants.WEBOS?17:20;break;case 8:_context7.next=10;return _regenerator.default.awrap((0,_web.buildWeb)(c,platform));case 10:return _context7.abrupt("return");case 11:_context7.next=13;return _regenerator.default.awrap((0,_firefox.buildFirefoxProject)(c,platform));case 13:return _context7.abrupt("return");case 14:_context7.next=16;return _regenerator.default.awrap((0,_tizen.buildTizenProject)(c,platform));case 16:return _context7.abrupt("return");case 17:_context7.next=19;return _regenerator.default.awrap(
(0,_webos.buildWebOSProject)(c,platform));case 19:return _context7.abrupt("return");case 20:


(0,_common.logErrorPlatform)(c,platform);case 21:case"end":return _context7.stop();}}},null,null,null,Promise);};


TASKS[_constants.TASK_BUILD]=_taskBuild;

var _taskDeploy=function _taskDeploy(c,parentTask){var platform;return _regenerator.default.async(function _taskDeploy$(_context8){while(1){switch(_context8.prev=_context8.next){case 0:
(0,_logger.logTask)('_taskDeploy',"parent:"+parentTask);

platform=c.platform;if(

c.program.only){_context8.next=5;break;}_context8.next=5;return _regenerator.default.awrap(
_taskExport(c));case 5:_context8.t0=


platform;_context8.next=_context8.t0===
_constants.WEB?8:_context8.t0===

_constants.CHROMECAST?9:10;break;case 8:return _context8.abrupt("return",(0,_web.deployWeb)(c,platform));case 9:return _context8.abrupt("return",
(0,_web.deployWeb)(c,platform));case 10:if(

c.program.only){_context8.next=13;break;}_context8.next=13;return _regenerator.default.awrap(
_taskExport(c));case 13:case"end":return _context8.stop();}}},null,null,null,Promise);};



TASKS[_constants.TASK_DEPLOY]=_taskDeploy;

var _taskDebug=function _taskDebug(c,parentTask){var platform;return _regenerator.default.async(function _taskDebug$(_context9){while(1){switch(_context9.prev=_context9.next){case 0:
(0,_logger.logTask)('_taskDebug',"parent:"+parentTask);

platform=c.platform;_context9.t0=

platform;_context9.next=_context9.t0===
_constants.WEB?5:_context9.t0===
_constants.TIZEN?5:6;break;case 5:return _context9.abrupt("return",
(0,_exec.executeAsync)(c,'npx weinre --boundHost -all-'));case 6:

(0,_common.logErrorPlatform)(c,platform);case 7:case"end":return _context9.stop();}}},null,null,null,Promise);};


TASKS[_constants.TASK_DEBUG]=_taskDebug;

var _taskLog=function _taskLog(c,parentTask){return _regenerator.default.async(function _taskLog$(_context10){while(1){switch(_context10.prev=_context10.next){case 0:
(0,_logger.logTask)('_taskLog',"parent:"+parentTask);

switch(c.platform){
default:
(0,_common.logErrorPlatform)(c,c.platform);}case 2:case"end":return _context10.stop();}}},null,null,null,Promise);};exports._taskLog=_taskLog;


TASKS[_constants.TASK_LOG]=_taskLog;

var runTask=function runTask(c,task){return _regenerator.default.async(function runTask$(_context11){while(1){switch(_context11.prev=_context11.next){case 0:
(0,_logger.logTask)('runTask','(engine-rn-web)');_context11.next=3;return _regenerator.default.awrap(

(0,_platformTools.isPlatformSupported)(c));case 3:_context11.next=5;return _regenerator.default.awrap(
(0,_common.isBuildSchemeSupported)(c));case 5:_context11.next=7;return _regenerator.default.awrap(
(0,_sdkManager.checkSdk)(c));case 7:_context11.next=9;return _regenerator.default.awrap(
applyTemplate(c));case 9:_context11.next=11;return _regenerator.default.awrap(
(0,_pluginTools.resolvePluginDependants)(c));case 11:

_analytics.default.captureEvent({
type:task+"Project",
platform:c.platform});return _context11.abrupt("return",

TASKS[task](c));case 13:case"end":return _context11.stop();}}},null,null,null,Promise);};


var applyTemplate=function applyTemplate(){return _regenerator.default.async(function applyTemplate$(_context12){while(1){switch(_context12.prev=_context12.next){case 0:return _context12.abrupt("return",true);case 1:case"end":return _context12.stop();}}},null,null,null,Promise);};var _default=

{
runTask:runTask,
applyTemplate:applyTemplate};exports.default=_default;
//# sourceMappingURL=index.js.map