var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.default=exports._taskLog=exports._taskStart=exports._taskConfigure=void 0;var _regenerator=_interopRequireDefault(require("@babel/runtime/regenerator"));
var _path=_interopRequireDefault(require("path"));
var _fs=_interopRequireDefault(require("fs"));
var _common=require("../../common");






var _resolve=require("../../resolve");
var _platformTools=require("../../platformTools");
var _logger=require("../../systemTools/logger");
var _constants=require("../../constants");









var _projectTools=require("../../projectTools");
var _apple=require("../../platformTools/apple");







var _android=require("../../platformTools/android");






var _exec=require("../../systemTools/exec");
var _analytics=_interopRequireDefault(require("../../systemTools/analytics"));

var _bundler=require("../../platformTools/bundler");
var _sdkManager=require("../../platformTools/sdkManager");
var _pluginTools=require("../../pluginTools");
var _fileutils=require("../../systemTools/fileutils");

var TASKS={};

var keepRNVRunning=false;

var waitForBundlerIfRequired=function waitForBundlerIfRequired(c){var bundleAssets;return _regenerator.default.async(function waitForBundlerIfRequired$(_context){while(1){switch(_context.prev=_context.next){case 0:
bundleAssets=(0,_common.getConfigProp)(c,c.platform,'bundleAssets');if(!(
bundleAssets===true)){_context.next=3;break;}return _context.abrupt("return");case 3:if(!

keepRNVRunning){_context.next=5;break;}return _context.abrupt("return",new Promise(function(){}));case 5:return _context.abrupt("return",
true);case 6:case"end":return _context.stop();}}},null,null,null,Promise);};


var _startBundlerIfRequired=function _startBundlerIfRequired(c,parentTask){var bundleAssets,isRunning;return _regenerator.default.async(function _startBundlerIfRequired$(_context2){while(1){switch(_context2.prev=_context2.next){case 0:
(0,_logger.logTask)('_startBundlerIfRequired');
bundleAssets=(0,_common.getConfigProp)(c,c.platform,'bundleAssets');if(!(
bundleAssets===true)){_context2.next=4;break;}return _context2.abrupt("return");case 4:_context2.next=6;return _regenerator.default.awrap(

(0,_bundler.isBundlerActive)(c));case 6:isRunning=_context2.sent;if(
isRunning){_context2.next=14;break;}
_taskStart(c,parentTask);
keepRNVRunning=true;_context2.next=12;return _regenerator.default.awrap(
(0,_bundler.waitForBundler)(c));case 12:_context2.next=16;break;case 14:_context2.next=16;return _regenerator.default.awrap(

(0,_common.confirmActiveBundler)(c));case 16:case"end":return _context2.stop();}}},null,null,null,Promise);};



var _configureMetroConfigs=function _configureMetroConfigs(c,platform){var configDir,dest;return _regenerator.default.async(function _configureMetroConfigs$(_context3){while(1){switch(_context3.prev=_context3.next){case 0:
configDir=_path.default.join(c.paths.project.dir,'configs');
if(!_fs.default.existsSync(configDir)){
(0,_fileutils.mkdirSync)(configDir);
}
dest=_path.default.join(configDir,"metro.config."+platform+".js");
if(!_fs.default.existsSync(dest)){
(0,_fileutils.writeFileSync)(
dest,"const { EXTENSIONS } = require('rnv/dist/constants');\nconst config = require('../metro.config');\n\nconfig.resolver.sourceExts = EXTENSIONS."+



platform+";\nmodule.exports = config;\n");



}



if(!_fs.default.existsSync(c.paths.project.rnCliConfig)){
(0,_logger.logInfo)("Looks like your rn-cli config file "+
(0,_logger.chalk)().white(
c.paths.project.rnCliConfig)+" is missing! Let's create one for you.");


(0,_fileutils.copyFileSync)(
_path.default.join(c.paths.rnv.projectTemplate.dir,_constants.RN_CLI_CONFIG_NAME),
c.paths.project.rnCliConfig);

}case 5:case"end":return _context3.stop();}}},null,null,null,Promise);};



var BUNDLER_PLATFORMS={};

BUNDLER_PLATFORMS[_constants.IOS]=_constants.IOS;
BUNDLER_PLATFORMS[_constants.TVOS]=_constants.IOS;
BUNDLER_PLATFORMS[_constants.ANDROID]=[_constants.ANDROID];
BUNDLER_PLATFORMS[_constants.ANDROID_TV]=[_constants.ANDROID];
BUNDLER_PLATFORMS[_constants.ANDROID_WEAR]=[_constants.ANDROID];

var _taskConfigure=function _taskConfigure(c,parentTask){return _regenerator.default.async(function _taskConfigure$(_context4){while(1){switch(_context4.prev=_context4.next){case 0:
(0,_logger.logTask)('_taskConfigure',"parent:"+parentTask);_context4.next=3;return _regenerator.default.awrap(

(0,_platformTools.configureGenericPlatform)(c));case 3:_context4.next=5;return _regenerator.default.awrap(
(0,_projectTools.configureGenericProject)(c));case 5:_context4.t0=

c.platform;_context4.next=_context4.t0===
_constants.IOS?8:_context4.t0===
_constants.TVOS?8:_context4.t0===

_constants.ANDROID?9:_context4.t0===
_constants.ANDROID_TV?9:_context4.t0===
_constants.ANDROID_WEAR?9:10;break;case 8:return _context4.abrupt("return",(0,_apple.configureXcodeProject)(c));case 9:return _context4.abrupt("return",
(0,_android.configureGradleProject)(c));case 10:return _context4.abrupt("return",

(0,_common.logErrorPlatform)(c));case 11:case"end":return _context4.stop();}}},null,null,null,Promise);};exports._taskConfigure=_taskConfigure;


TASKS[_constants.TASK_CONFIGURE]=_taskConfigure;

var _taskStart=function _taskStart(c,parentTask){var platform,hosted,startCmd,url;return _regenerator.default.async(function _taskStart$(_context5){while(1){switch(_context5.prev=_context5.next){case 0:
platform=c.platform;
hosted=c.program.hosted;

(0,_logger.logTask)('_taskStart',"parent:"+parentTask+" port:"+c.runtime.port+" hosted:"+!!hosted);if(!

hosted){_context5.next=5;break;}return _context5.abrupt("return",
(0,_logger.logError)(
'This platform does not support hosted mode',
true));case 5:if(!(



!c.program.only&&!parentTask)){_context5.next=8;break;}_context5.next=8;return _regenerator.default.awrap(
_taskConfigure(c,_constants.TASK_START));case 8:_context5.t0=


platform;_context5.next=_context5.t0===
_constants.IOS?11:_context5.t0===
_constants.TVOS?11:_context5.t0===
_constants.ANDROID?11:_context5.t0===
_constants.ANDROID_TV?11:_context5.t0===
_constants.ANDROID_WEAR?11:16;break;case 11:
startCmd="node "+(0,_resolve.doResolve)(
'react-native')+"/local-cli/cli.js start --port "+

c.runtime.port+" --config=configs/metro.config."+
c.platform+".js";

if(c.program.resetHard){
startCmd+=' --reset-cache';
}else if(c.program.reset&&c.command==='start'){
startCmd+=' --reset-cache';
}

url=(0,_logger.chalk)().cyan("http://"+c.runtime.localhost+":"+c.runtime.port+"/"+
(0,_common.getEntryFile)(c,c.platform)+".bundle?platform="+BUNDLER_PLATFORMS[platform]);
(0,_logger.logRaw)("\n\nDev server running at: "+

url+"\n\n");return _context5.abrupt("return",


(0,_exec.executeAsync)(c,startCmd,{stdio:'inherit',silent:true}));case 16:return _context5.abrupt("return",



(0,_common.logErrorPlatform)(c,platform));case 17:case"end":return _context5.stop();}}},null,null,null,Promise);};exports._taskStart=_taskStart;


TASKS[_constants.TASK_START]=_taskStart;

var _taskRun=function _taskRun(c,parentTask){var platform,port,target,hosted,bundleAssets;return _regenerator.default.async(function _taskRun$(_context6){while(1){switch(_context6.prev=_context6.next){case 0:
platform=c.platform;
port=c.runtime.port;
target=c.runtime.target;
hosted=c.program.hosted;
(0,_logger.logTask)('_taskRun',"parent:"+parentTask+" port:"+port+" target:"+target+" hosted:"+hosted);

bundleAssets=(0,_common.getConfigProp)(c,c.platform,'bundleAssets',false);if(

c.program.only){_context6.next=9;break;}_context6.next=9;return _regenerator.default.awrap(
_taskConfigure(c,_constants.TASK_RUN));case 9:_context6.t0=


platform;_context6.next=_context6.t0===
_constants.IOS?12:_context6.t0===
_constants.TVOS?12:_context6.t0===









_constants.ANDROID?20:_context6.t0===
_constants.ANDROID_TV?20:_context6.t0===
_constants.ANDROID_WEAR?20:31;break;case 12:if(c.program.only){_context6.next=19;break;}_context6.next=15;return _regenerator.default.awrap(_startBundlerIfRequired(c,_constants.TASK_RUN));case 15:_context6.next=17;return _regenerator.default.awrap((0,_apple.runXcodeProject)(c));case 17:if(!bundleAssets){(0,_logger.logSummary)('BUNDLER STARTED');}return _context6.abrupt("return",waitForBundlerIfRequired(c));case 19:return _context6.abrupt("return",(0,_apple.runXcodeProject)(c));case 20:if(
c.program.only){_context6.next=30;break;}_context6.next=23;return _regenerator.default.awrap(
_startBundlerIfRequired(c,_constants.TASK_RUN));case 23:if(!(

(0,_common.getConfigProp)(c,platform,'bundleAssets')===true||
platform===_constants.ANDROID_WEAR)){_context6.next=26;break;}_context6.next=26;return _regenerator.default.awrap(

(0,_android.packageAndroid)(c,platform));case 26:_context6.next=28;return _regenerator.default.awrap(

(0,_android.runAndroid)(c,platform,target));case 28:
if(!bundleAssets){
(0,_logger.logSummary)('BUNDLER STARTED');
}return _context6.abrupt("return",
waitForBundlerIfRequired(c));case 30:return _context6.abrupt("return",

(0,_android.runAndroid)(c,platform,target));case 31:return _context6.abrupt("return",

(0,_common.logErrorPlatform)(c,platform));case 32:case"end":return _context6.stop();}}},null,null,null,Promise);};


TASKS[_constants.TASK_RUN]=_taskRun;


var _taskPackage=function _taskPackage(c,parentTask){var platform,target;return _regenerator.default.async(function _taskPackage$(_context7){while(1){switch(_context7.prev=_context7.next){case 0:
(0,_logger.logTask)('_taskPackage',"parent:"+parentTask);
platform=c.platform;

target=c.program.target||c.files.workspace.config.defaultTargets[platform];if(

c.program.only){_context7.next=6;break;}_context7.next=6;return _regenerator.default.awrap(
_taskConfigure(c,_constants.TASK_PACKAGE));case 6:_context7.t0=


platform;_context7.next=_context7.t0===
_constants.IOS?9:_context7.t0===
_constants.TVOS?9:_context7.t0===

_constants.ANDROID?10:_context7.t0===
_constants.ANDROID_TV?10:_context7.t0===
_constants.ANDROID_WEAR?10:11;break;case 9:return _context7.abrupt("return",(0,_apple.packageBundleForXcode)(c));case 10:return _context7.abrupt("return",
(0,_android.packageAndroid)(
c,
platform,
target,
platform===_constants.ANDROID_WEAR));case 11:


(0,_common.logErrorPlatform)(c,platform);return _context7.abrupt("return",
false);case 13:case"end":return _context7.stop();}}},null,null,null,Promise);};


TASKS[_constants.TASK_PACKAGE]=_taskPackage;


var _taskExport=function _taskExport(c,parentTask){var platform;return _regenerator.default.async(function _taskExport$(_context8){while(1){switch(_context8.prev=_context8.next){case 0:
(0,_logger.logTask)('_taskExport',"parent:"+parentTask);
platform=c.platform;_context8.t0=

platform;_context8.next=_context8.t0===
_constants.IOS?5:_context8.t0===
_constants.TVOS?5:_context8.t0===




_constants.ANDROID?9:_context8.t0===
_constants.ANDROID_TV?9:_context8.t0===
_constants.ANDROID_WEAR?9:10;break;case 5:if(c.program.only){_context8.next=8;break;}_context8.next=8;return _regenerator.default.awrap(_taskBuild(c,_constants.TASK_EXPORT));case 8:return _context8.abrupt("return",(0,_apple.exportXcodeProject)(c,platform));case 9:return _context8.abrupt("return",
_taskBuild(c,_constants.TASK_EXPORT));case 10:return _context8.abrupt("return",

(0,_common.logErrorPlatform)(c,platform));case 11:case"end":return _context8.stop();}}},null,null,null,Promise);};


TASKS[_constants.TASK_EXPORT]=_taskExport;

var _taskBuild=function _taskBuild(c,parentTask){var platform;return _regenerator.default.async(function _taskBuild$(_context9){while(1){switch(_context9.prev=_context9.next){case 0:
(0,_logger.logTask)('_taskBuild',"parent:"+parentTask);
platform=c.platform;if(

c.program.only){_context9.next=5;break;}_context9.next=5;return _regenerator.default.awrap(
_taskPackage(c,_constants.TASK_BUILD));case 5:_context9.t0=


platform;_context9.next=_context9.t0===
_constants.ANDROID?8:_context9.t0===
_constants.ANDROID_TV?8:_context9.t0===
_constants.ANDROID_WEAR?8:_context9.t0===

_constants.IOS?9:_context9.t0===
_constants.TVOS?9:12;break;case 8:return _context9.abrupt("return",(0,_android.buildAndroid)(c,platform));case 9:if(!(
parentTask===_constants.TASK_EXPORT)){_context9.next=11;break;}return _context9.abrupt("return",

true);case 11:return _context9.abrupt("return",

(0,_apple.buildXcodeProject)(c,platform));case 12:return _context9.abrupt("return",

(0,_common.logErrorPlatform)(c,platform));case 13:case"end":return _context9.stop();}}},null,null,null,Promise);};


TASKS[_constants.TASK_BUILD]=_taskBuild;

var _taskDeploy=function _taskDeploy(c,parentTask){return _regenerator.default.async(function _taskDeploy$(_context10){while(1){switch(_context10.prev=_context10.next){case 0:
(0,_logger.logTask)('_taskDeploy',"parent:"+parentTask);if(

c.program.only){_context10.next=5;break;}_context10.next=4;return _regenerator.default.awrap(
_taskExport(c,_constants.TASK_DEPLOY));case 4:return _context10.abrupt("return",
true);case 5:return _context10.abrupt("return",


true);case 6:case"end":return _context10.stop();}}},null,null,null,Promise);};

TASKS[_constants.TASK_DEPLOY]=_taskDeploy;

var _taskDebug=function _taskDebug(c,parentTask){var platform;return _regenerator.default.async(function _taskDebug$(_context11){while(1){switch(_context11.prev=_context11.next){case 0:
(0,_logger.logTask)('_taskDebug',"parent:"+parentTask);
platform=c.platform;_context11.t0=

platform;_context11.next=5;break;case 5:return _context11.abrupt("return",

(0,_common.logErrorPlatform)(c,platform));case 6:case"end":return _context11.stop();}}},null,null,null,Promise);};


TASKS[_constants.TASK_DEBUG]=_taskDebug;

var _taskLog=function _taskLog(c,parentTask){return _regenerator.default.async(function _taskLog$(_context12){while(1){switch(_context12.prev=_context12.next){case 0:
(0,_logger.logTask)('_taskLog',"parent:"+parentTask);_context12.t0=
c.platform;_context12.next=_context12.t0===
_constants.ANDROID?4:_context12.t0===
_constants.ANDROID_TV?4:_context12.t0===
_constants.ANDROID_WEAR?4:_context12.t0===

_constants.IOS?5:_context12.t0===
_constants.TVOS?5:6;break;case 4:return _context12.abrupt("return",(0,_android.runAndroidLog)(c));case 5:return _context12.abrupt("return",
(0,_apple.runAppleLog)(c));case 6:return _context12.abrupt("return",

(0,_common.logErrorPlatform)(c,c.platform));case 7:case"end":return _context12.stop();}}},null,null,null,Promise);};exports._taskLog=_taskLog;


TASKS[_constants.TASK_LOG]=_taskLog;

var runTask=function runTask(c,task){return _regenerator.default.async(function runTask$(_context13){while(1){switch(_context13.prev=_context13.next){case 0:
(0,_logger.logTask)('runTask',"task:"+task+" engine:engine-rn");_context13.next=3;return _regenerator.default.awrap(
(0,_platformTools.isPlatformSupported)(c));case 3:_context13.next=5;return _regenerator.default.awrap(
(0,_common.isBuildSchemeSupported)(c));case 5:_context13.next=7;return _regenerator.default.awrap(
(0,_sdkManager.checkSdk)(c));case 7:_context13.next=9;return _regenerator.default.awrap(
applyTemplate(c));case 9:_context13.next=11;return _regenerator.default.awrap(
(0,_pluginTools.resolvePluginDependants)(c));case 11:

_analytics.default.captureEvent({
type:task+"Project",
platform:c.platform});return _context13.abrupt("return",

TASKS[task](c));case 13:case"end":return _context13.stop();}}},null,null,null,Promise);};


var applyTemplate=function applyTemplate(c){return _regenerator.default.async(function applyTemplate$(_context14){while(1){switch(_context14.prev=_context14.next){case 0:_context14.next=2;return _regenerator.default.awrap(
_configureMetroConfigs(c,c.platform));case 2:return _context14.abrupt("return",
true);case 3:case"end":return _context14.stop();}}},null,null,null,Promise);};var _default=


{
runTask:runTask,
applyTemplate:applyTemplate};exports.default=_default;
//# sourceMappingURL=index.js.map