var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.rnvLink=exports.rnvSwitch=exports.configureGenericProject=void 0;var _regenerator=_interopRequireDefault(require("@babel/runtime/regenerator"));

var _path=_interopRequireDefault(require("path"));
var _fs=_interopRequireDefault(require("fs"));
var _common=require("../common");
var _resolve=require("../resolve");
var _logger=require("../systemTools/logger");
var _fileutils=require("../systemTools/fileutils");


var _cli=_interopRequireDefault(require("../cli"));
var _projectParser=require("./projectParser");
var _configParser=require("../configTools/configParser");
var _packageParser=require("../configTools/packageParser");
var _pluginTools=require("../pluginTools");

var configureGenericProject=function configureGenericProject(c){return _regenerator.default.async(function configureGenericProject$(_context){while(1){switch(_context.prev=_context.next){case 0:
(0,_logger.logTask)('configureGenericProject');_context.next=3;return _regenerator.default.awrap(

(0,_packageParser.injectPlatformDependencies)(c));case 3:_context.next=5;return _regenerator.default.awrap(
_checkAndCreatePlatforms(c));case 5:_context.next=7;return _regenerator.default.awrap(
(0,_projectParser.copyRuntimeAssets)(c));case 7:_context.next=9;return _regenerator.default.awrap(
(0,_projectParser.copySharedPlatforms)(c));case 9:_context.next=11;return _regenerator.default.awrap(
(0,_configParser.generateRuntimeConfig)(c));case 11:_context.next=13;return _regenerator.default.awrap(
(0,_pluginTools.overrideTemplatePlugins)(c));case 13:case"end":return _context.stop();}}},null,null,null,Promise);};exports.configureGenericProject=configureGenericProject;


var rnvSwitch=function rnvSwitch(c){return new Promise(function(resolve,reject){
var p=c.program.platform||'all';
(0,_logger.logTask)("rnvSwitch:"+p);

(0,_projectParser.copyRuntimeAssets)(c).
then(function(){return(0,_projectParser.copySharedPlatforms)(c);}).
then(function(){return(0,_configParser.generateRuntimeConfig)(c);}).
then(function(){return resolve();}).
catch(function(e){return reject(e);});
});};exports.rnvSwitch=rnvSwitch;

var rnvLink=function rnvLink(c){return new Promise(function(resolve){
if(_fs.default.existsSync(c.paths.project.npmLinkPolyfill)){
var l=JSON.parse(
_fs.default.readFileSync(c.paths.project.npmLinkPolyfill).toString());

Object.keys(l).forEach(function(key){
var source=_path.default.resolve(l[key]);
var nm=_path.default.join(source,'node_modules');
var dest=(0,_resolve.doResolve)(key);
if(_fs.default.existsSync(source)){
(0,_fileutils.copyFolderContentsRecursiveSync)(source,dest,false,[nm]);
}else{
(0,_logger.logWarning)("Source: "+source+" doesn't exists!");
}
});
}else{
(0,_logger.logWarning)(
c.paths.project.npmLinkPolyfill+" file not found. nothing to link!");

resolve();
}
});};exports.rnvLink=rnvLink;


var _checkAndCreatePlatforms=function _checkAndCreatePlatforms(c){var platform,appFolder,platforms,ks,i,k,_appFolder;return _regenerator.default.async(function _checkAndCreatePlatforms$(_context2){while(1){switch(_context2.prev=_context2.next){case 0:
(0,_logger.logTask)('_checkAndCreatePlatforms');
platform=c.platform;if(
_fs.default.existsSync(c.paths.project.builds.dir)){_context2.next=7;break;}
(0,_logger.logWarning)('Platforms not created yet. creating them for you...');_context2.next=6;return _regenerator.default.awrap(
(0,_cli.default)(c,{
command:'platform',
subCommand:'configure',
program:{appConfig:c.runtime.appId,platform:platform}}));case 6:return _context2.abrupt("return");case 7:if(!



platform){_context2.next=15;break;}
appFolder=(0,_common.getAppFolder)(c,platform);if(
_fs.default.existsSync(appFolder)){_context2.next=13;break;}
(0,_logger.logWarning)("Platform "+
platform+" not created yet. creating them for you at "+appFolder);_context2.next=13;return _regenerator.default.awrap(

(0,_cli.default)(c,{
command:'platform',
subCommand:'configure',
program:{appConfig:c.runtime.appId,platform:platform}}));case 13:_context2.next=30;break;case 15:



platforms=c.buildConfig.platforms;if(
platforms){_context2.next=18;break;}return _context2.abrupt("return",
Promise.reject("Your "+
(0,_logger.chalk)().white(
c.paths.appConfig.config)+" is missconfigured. (Maybe you have older version?). Missing "+
(0,_logger.chalk)().white(
'{ platforms: {} }')+" object at root"));case 18:



ks=Object.keys(platforms);
i=0;case 20:if(!(i<ks.length)){_context2.next=30;break;}
k=ks[i];
_appFolder=(0,_common.getAppFolder)(c,k);if(
_fs.default.existsSync(_appFolder)){_context2.next=27;break;}
(0,_logger.logWarning)("Platform "+
k+" not created yet. creating one for you at "+_appFolder);_context2.next=27;return _regenerator.default.awrap(

(0,_cli.default)(c,{
command:'platform',
subCommand:'configure',
platform:k,
program:{appConfig:c.runtime.appId,platform:k}}));case 27:i++;_context2.next=20;break;case 30:case"end":return _context2.stop();}}},null,null,null,Promise);};
//# sourceMappingURL=index.js.map